
def load_codon_usage(filename):
	usage = {}
	f = open(filename)

	for row in f:
		data = row.split()
		usage[data[0]] = float(data[1])

	return usage

def load_sequence(filename):
	seq = ""
	f = open(filename)

	for row in f.readlines()[1:]:
		seq += row.strip()

	return seq

def compute_codon_usage(seq):
	usage = {}
	numcodons = 0

	for i in range(0,len(seq),3):		
		codon = seq[i:i+3]
		if codon in usage:
			usage[codon] +=1
		else:
			usage[codon] = 1
		numcodons += 1
			
	for codon in usage.keys():
		usage[codon] /= numcodons

	return usage

def print_usage(seq_usage, avg_usage):
	for (codon, freq) in seq_usage.items():
		print("%s\t%.4f\t%.4f" %(codon,freq,avg_usage[codon]))


usage_file = input("Usage table file: ")
sequence_file = input("Sequence file: ")

usage_table = load_codon_usage(usage_file)
seq = load_sequence(sequence_file)

seq_usage = compute_codon_usage(seq)

print_usage(seq_usage, usage_table)


